
#include "stdafx.h"
#include "resource.h"



//----------------------------------------------------------------------------
// [eBeB[
//----------------------------------------------------------------------------

#ifndef ListView_SetCheckState
#define ListView_SetCheckState(_hwndLV, _i, _fCheck) \
	ListView_SetItemState(_hwndLV, _i, \
	INDEXTOSTATEIMAGEMASK((_fCheck)+1), LVIS_STATEIMAGEMASK)
#endif

static void move_later( const char* from, const char* to )
{
	// ړƓfBNg֓Ă
	kiPath tmp( to );
	::CopyFile( from, tmp+=".tmp", FALSE );
	::DeleteFile( from );

	// NTnȂMoveFileEx͂
	if( ::MoveFileEx( tmp, to, MOVEFILE_REPLACE_EXISTING|MOVEFILE_DELAY_UNTIL_REBOOT ) )
		return;

	// 9xnȂWININIT.INI
	char inifile[MAX_PATH];
	::GetWindowsDirectory( inifile, sizeof(inifile) );
	::lstrcat( inifile, "\\WININIT.INI" );

	// V[gOɕϊ
	char sfrom[MAX_PATH], sto[MAX_PATH];
	::GetShortPathName(  tmp, sfrom, MAX_PATH );
	::GetShortPathName(   to,   sto, MAX_PATH );

	// RenameZNVɒǉ
	static char buf[30000];
	::GetPrivateProfileSection( "Rename", buf, 30000, inifile ); 
	char* p = buf; 
	while(*p)while(*p++);
	::lstrcpy( p, "NUL=" );
	::lstrcat( p, sto );
	::lstrcat( p, "\r\n" );
	::lstrcat( p, sto );
	::lstrcat( p, "=" );
	::lstrcat( p, sfrom );
	while(*p++);
	*p='\0'; 

	// QłĊmɏ
	::WritePrivateProfileSection( "Rename", buf, inifile );
	::WritePrivateProfileString( NULL, NULL, NULL, inifile );
}

static void rebootWindows()
{
	if( app()->osver().dwPlatformId == VER_PLATFORM_WIN32_NT )
	{
		// NTnł͓擾ȂĂ͂Ȃ
		HANDLE hToken;
		TOKEN_PRIVILEGES tkp;
		::OpenProcessToken( ::GetCurrentProcess(),
			TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY, &hToken );
		::LookupPrivilegeValue(
			NULL, SE_SHUTDOWN_NAME, &tkp.Privileges[0].Luid );
		tkp.PrivilegeCount = 1;
		tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
		::AdjustTokenPrivileges( hToken, FALSE, &tkp, 0, NULL, 0 );
	}
	::ExitWindowsEx( EWX_REBOOT, 0 );
}

static bool cancelShiteIidesuka()
{
	return IDYES == app()->msgBox( kiStr().loadRsrc( IDS_CANCELOK ),
		"caldix", MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 );
}

template <class T> static inline bool show( const T& dlg )
{
	(const_cast<T&>(dlg)).doModal();
	return IDOK == (const_cast<T&>(dlg)).getEndCode();
}



//----------------------------------------------------------------------------
// 𓀊֌W
//----------------------------------------------------------------------------

#include "kiutil.h"
#include "LzhTool.h"
#include "CabTool.h"
#include "ZipTool.h"
#define is_lzh(xx) (xx[2]=='-' && xx[3]=='l' && xx[4]=='h' && xx[6]=='-' && '0'<=xx[5] && xx[5]<='9')
#define is_zip(xx) (xx[2]=='P' && xx[3]=='K' && xx[4]==0x3 && xx[6]==0x4)
#define is_cab(xx) (xx[0]=='M' && xx[1]=='S' && xx[2]=='C' && xx[3]=='F')

enum arctype{ e_lzh, e_zip, e_cab, unknown };

static arctype get_archive_type( const char* arcname )
{
	// 蔲
	arctype ans = unknown;
	kiFile fp;
	if( fp.open(arcname) )
	{
		unsigned long asize = 128 << 10;
		unsigned char *buf = new unsigned char[asize];
		unsigned char *p=buf, *end=buf+fp.read( buf, asize-6 );

		while( p!=end )
		{
				 if( is_lzh(p) ) { ans=e_lzh; break; }
			else if( is_zip(p) ) { ans=e_zip; break; }
			else if( is_cab(p) ) { ans=e_cab; break; }
			p++;
		}

		delete [] buf;
	}
	return ans;
}

static void melt_it( const char* arcname, const char* dllname, kiPath& dll_rel_path )
{
	const char* ext = kiPath::ext( arcname );
	arctype type = unknown;

	// 
		 if( 0==stricmp( ext, "lzh" ) ) type = e_lzh;
	else if( 0==stricmp( ext, "zip" ) ) type = e_zip;
	else if( 0==stricmp( ext, "cab" ) ) type = e_cab;
	else type = get_archive_type(arcname);

	// WJ
	switch( type )
	{
	case e_lzh:{ CLzhTool().Extract( arcname, dllname, dll_rel_path ); }break;
	case e_zip:{ CZipTool().Extract( arcname, dllname, dll_rel_path ); }break;
	case e_cab:{ CCabTool().Extract( arcname, dllname, dll_rel_path ); }break;
	}
}



//----------------------------------------------------------------------------
// DLLǗFMeta-WWWC-Content̉͂Ȃ
//----------------------------------------------------------------------------

class DLLInfo
{
public:

	DLLInfo( const char* _name, const char* _html, int _wwwc )
		: name( _name ), html( _html ), wwwc( _wwwc ), size( 0 ) {}

	bool  ParseHTML( char* str );
	const kiStr& htmlName() const { return html; }
	bool  needToUpdate( kiPath& dlldir );
	const kiStr& getName() const { return name; }
	const kiStr& getState() const { return stat; }
	const int getSize() const { return size; }
	const kiStr& getArchiveName() const { return arch; }

private:

	char* Get_WWWC_Content( char* str );
	bool  ParseWWWC( char* str );
	bool  CheckDateTime( const char* localDLL );

private:

	// Œ
	const kiStr name; // DLL̖O
	const kiStr html; // `FbNHTML̖O
	const int   wwwc; // ԖڂWWWC^O𗘗p邩

private:

	// HTML擾
	kiStr       arch; // ɖ
	kiStr       vers; // o[W
	kiStr       dttm; // t&
	int         size; // TCY

	// o[Wƍ̌
	kiStr       stat; // XV
};

char* DLLInfo::Get_WWWC_Content( char* x )
{
	// [ɎGB
	while( *x==' ' || *x=='\t' || *x=='\r' || *x=='\n' ) x++;
	if( (x[0]=='m' || x[0]=='M')
	 && (x[1]=='e' || x[1]=='E')
	 && (x[2]=='t' || x[2]=='T')
	 && (x[3]=='a' || x[3]=='A') )
	{
		x+=4;
		while( *x==' ' || *x=='\t' || *x=='\r' || *x=='\n' ) x++;
		if( (x[0]=='n' || x[0]=='N')
		 && (x[1]=='a' || x[1]=='A')
		 && (x[2]=='m' || x[2]=='M')
		 && (x[3]=='e' || x[3]=='E')
		 &&       (x[4]=='=')
		 &&       (x[5]=='"')
		 && (x[6]=='w' || x[6]=='W')
		 && (x[7]=='w' || x[7]=='W')
		 && (x[8]=='w' || x[8]=='W')
		 && (x[9]=='c' || x[9]=='C')
		 &&       (x[10]=='"') )
		{
			x+=11;
			while( *x==' ' || *x=='\t' || *x=='\r' || *x=='\n' ) x++;
			if( (x[0]=='c' || x[0]=='C')
			 && (x[1]=='o' || x[1]=='O')
			 && (x[2]=='n' || x[2]=='N')
			 && (x[3]=='t' || x[3]=='T')
			 && (x[4]=='e' || x[4]=='E')
			 && (x[5]=='n' || x[5]=='N')
			 && (x[6]=='t' || x[6]=='T')
			 &&       (x[7]=='=')
			 &&       (x[8]=='"') )
			{
				x+=9;
				char* p=x;
				while( *p!='\0' && *p!='"' ) p++;
				*p='\0';
				return x;
			}
		}
	}
	return NULL;
}

bool DLLInfo::ParseHTML( char* str )
{
	int ct = wwwc;
	for( char* p=str; *p; ++p )
		if( *p == '<' )
		{
			for( char* x=p+1; *x; ++x )
				if( *x == '>' )
					break;
			*x = '\0';

			char* w = Get_WWWC_Content( p+1 );
			if( w && (--ct)==0 )
				return ParseWWWC( w );

			p = x;
		}
	return false;
}

bool DLLInfo::ParseWWWC( char* str )
{
	char *x,*k,*t,*p=str;

	// Qڂ̃Xy[X܂łXV
	for( int spc=2; *p; ++p )
		if( *p==' ' )
			if( (--spc)==0 )
				break;
	if( *p=='\0' )
		return false;
	*(p++) = '\0';
	dttm = str;

	// [xxx: ---] 
	while( true )
	{
		while( *p!='\0' && *p!='[' ) ++p;
		if( *p!='\0' ) ++p;
		if( *p=='\0' )break;

		t=x=k=p;
		while( *x!='\0' && *x!=']' ) x++;
		while( *k!='\0' && *k!=':' ) k++;
		if( *x=='\0' || *k=='\0' || k>=x )break;
		*k=*x='\0';
		p=k+1;

		if( 0==lstrcmpi( t, "File" ) )
			arch = p;
		else if( 0==lstrcmpi( t, "Ver" ) )
		{
			while( *p && (*p<'0' || '9'<*p) )
				++p;
			vers = p;
		}
		else if( 0==lstrcmpi( t, "Size" ) )
		{
			// atoi
			for( int n=0; *p; p++ )
				if( '0'<=*p && *p<='9' )
					n = (10*n) + (*p - '0');
			size = n;
		}
		p=x+1;
	}

	return ( size!=0 && arch.len()!=0 );
}

//----------------------------------------------------------------------------
// caldix̐ݒ荀ڊǗ
//----------------------------------------------------------------------------

enum {
	UNLHA, UNZIP, ZIP, CAB, TAR, UNRAR, UNGCA,
	UNARJ, YZ1, BGA, JACK, AISH, ISH, UNBEL, SvZIP,
DLLID_NUM };

struct CldxConfig
{
	kiStr   UA;            // [U[G[WFg

	bool    SuperAutoMode; // ipȂj
	bool    AutoMode;      // SȂtrue, JX^Ȃfalse

	kiPath  InstallTo;     // CXg[
	bool    CsdFirst;      // CSDɌqȂtrue, fȂfalse

	int     ProxyPort;     // vLṼ|[gԍ
	kiStr   ProxyServer;   // vLVT[o
	kiStr   ProxyUser;     // vLV[UipȂj
	kiStr   ProxyPwd;      // vLVpX[hipȂj

	bool    George;        // 펞ڑ[hȂtrue, ėp[hȂfalse
	bool    UseCustomDir;  // SłAJX^ƓfBNgp
	bool    ShowReadMe;    // ŌcldxtH_Jۂ

	bool    DoCheck[DLLID_NUM]; // eDLL`FbNΏۂɂ邩ǂ
	int     InstMode;           // _E[hDLL̈
	int     Expire;             // `FbNōXVΏۂƂ͈(P:Day)

	kiArray<DLLInfo*> List;     // `FbNΏDLL̃Xg

	CldxConfig()
		: UA( "caldix/1.11" )
		, SuperAutoMode( false )
		, AutoMode( true )
		, InstallTo( kiPath::Sys )
	{
		kiIniFile ini;
		ini.setFileName( "caldix.ini" );
		ini.setSection( "conf" );

		InstallTo    = ini.getStr ( "dll",       InstallTo );
		CsdFirst     = ini.getBool( "csd",       false );
		ProxyServer  = ini.getStr ( "proxy",     "" );
		ProxyPort    = ini.getInt ( "proxyport", -80 );
		George       =!ini.getBool( "askhang",   true );
		UseCustomDir = ini.getBool( "custdir",   false );
		ShowReadMe   = ini.getBool( "readme",    true );
		InstMode     = ini.getInt ( "mode",      1 );
		Expire       = ini.getInt ( "expire",    7 );
		int version  = ini.getInt ( "ver",     110 );

		for( int i=0; i<DLLID_NUM; ++i )
			DoCheck[i] = false;
		const char* ptr = ini.getStr( "DLLList", "LZzCTRGAYBJaIb7" );
		while( *ptr )
			switch( 0x7f & (*(ptr++)) )
			{
			case 'L': DoCheck[UNLHA] = true; break;
			case 'Z': DoCheck[UNZIP] = true; break;
			case 'z': DoCheck[ZIP]   = true; break;
			case 'C': DoCheck[CAB]   = true; break;
			case 'T': DoCheck[TAR]   = true; break;
			case 'R': DoCheck[UNRAR] = true; break;
			case 'G': DoCheck[UNGCA] = true; break;
			case 'A': DoCheck[UNARJ] = true; break;
			case 'Y': DoCheck[YZ1]   = true; break;
			case 'B': DoCheck[BGA]   = true; break;
			case 'J': DoCheck[JACK]  = true; break;
			case 'a': DoCheck[AISH]  = true; break;
			case 'I': DoCheck[ISH]   = true; break;
			case 'b': DoCheck[UNBEL] = true; break;
			case '7': DoCheck[SvZIP] = true; break;
			}
		if( version<111 && !DoCheck[SvZIP] )
			DoCheck[SvZIP] = true; // ver1.11Oɂ7-zip32.dll
			                       // ݂Ȃ̂łŋON
	}

	void GenerateDLLList()
	{
		if( DoCheck[UNLHA] )
			List.add( new DLLInfo(  "Unlha32.dll",  "unlha32.html", 1 ) );
		if( DoCheck[UNZIP] )
			List.add( new DLLInfo(  "UnZip32.dll",  "unzip32.html", 1 ) );
		if( DoCheck[ZIP]   )
			List.add( new DLLInfo(   "Zip32j.dll",   "zip32j.html", 1 ) ),
			List.add( new DLLInfo(    "Zip32.dll",   "zip32j.html", 2 ) ),
			List.add( new DLLInfo( "Sfx32gui.dat", "sfx32gui.html", 1 ) );
		if( DoCheck[CAB]   )
			List.add( new DLLInfo(    "Cab32.dll",    "cab32.html", 1 ) );
		if( DoCheck[TAR]   )
			List.add( new DLLInfo(    "Tar32.dll",    "tar32.html", 1 ) );
		if( DoCheck[UNRAR] )
			List.add( new DLLInfo(  "Unrar32.dll",  "unrar32.html", 1 ) );
		if( DoCheck[UNGCA] )
			List.add( new DLLInfo(  "UnGCA32.dll",  "ungca32.html", 1 ) );
		if( DoCheck[UNARJ] )
			List.add( new DLLInfo( "Unarj32j.dll",  "unarj32.html", 1 ) );
		if( DoCheck[YZ1]   )
			List.add( new DLLInfo(      "Yz1.dll",      "yz1.html", 1 ) );
		if( DoCheck[BGA]   )
			List.add( new DLLInfo(    "Bga32.dll",    "bga32.html", 1 ) );
		if( DoCheck[JACK]  )
			List.add( new DLLInfo(   "Jack32.dll",   "jack32.html", 1 ) );
		if( DoCheck[AISH]  )
			List.add( new DLLInfo(   "Aish32.dll",   "aish32.html", 1 ) );
		if( DoCheck[ISH]   )
			List.add( new DLLInfo(    "Ish32.dll",    "ish32.html", 1 ) );
		if( DoCheck[UNBEL] )
			List.add( new DLLInfo(  "Unbel32.dll",  "unbel32.html", 1 ) );
		if( DoCheck[SvZIP] )
			List.add( new DLLInfo(  "7-zip32.dll",  "7-zip32.html", 1 ) );
	}

	~CldxConfig()
	{
		if( !AutoMode )
		{
			kiIniFile ini;
			ini.setFileName( "caldix.ini" );
			ini.setSection( "conf" );

			ini.putStr ( "dll",       InstallTo );
			ini.putBool( "csd",       CsdFirst );
			ini.putStr ( "proxy",     ProxyServer );
			ini.putInt ( "proxyport", ProxyPort );
			ini.putBool( "askhang",  !George );
			ini.putBool( "custdir",   UseCustomDir );
			ini.putBool( "readme",    ShowReadMe );
			ini.putInt ( "mode",      InstMode );
			ini.putInt ( "expire",    Expire );
			ini.putInt ( "ver",       111 );

			kiStr chk;
			for( int i=0; i<DLLID_NUM; ++i )
				if( DoCheck[i] )
					chk += "LZzCTRGAYBJaIb7"[i];
			ini.putStr( "DLLList", chk );
		}

		for( unsigned int i=0; i<List.len(); ++i )
			delete List[i];
	}
};

CldxConfig* cfg = NULL;



//----------------------------------------------------------------------------
// DLL̃o[W`FbN
//----------------------------------------------------------------------------

struct _zip_version_type
{
	unsigned char major;
	unsigned char minor;
	unsigned char patchlevel;
	unsigned char not_used;
};

struct ZpVer
{
	unsigned long structlen;
	unsigned long flag;
	char betalevel[10];
	char date[20];
	char zlib_version[10];
	_zip_version_type zip;
	_zip_version_type os2dll;
	_zip_version_type windll;
};

static WORD Zip32DLLGetVersion( const char* dll )
{
	WORD ans=0;
	HINSTANCE inst = ::LoadLibrary( dll );
	if( inst )
	{
		typedef int (WINAPI * ZPVR)(ZpVer*);
		ZPVR v = (ZPVR)::GetProcAddress( inst, "ZpVersion" );
		if( v )
		{
			ZpVer x;
			v( &x );
			ans = x.zip.major*100 + x.zip.minor*10 + x.zip.patchlevel;
		}
		::FreeLibrary( inst );
	}
	return ans;
}
/*
static WORD UnrarDLLGetVersion( const char* dllpath )
{
	kiPath dll( dllpath );
	dll += "unrar.dll";

	WORD ans=0;
	if( HINSTANCE inst = ::LoadLibrary( dll ) )
	{
		typedef int (PASCAL * RRGV)();
		RRGV r = (RRGV)::GetProcAddress( inst, "RARGetDllVersion" );
		if( r )
			ans = (WORD)r();
		::FreeLibrary( inst );
	}
	return ans;
}
*/
bool DLLInfo::CheckDateTime( const char* localDLL )
{
	// [JDLL̓t擾
	FILETIME ft;
	SYSTEMTIME StLocal;
	HANDLE h = ::CreateFile(
		localDLL, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL );
	if( h == INVALID_HANDLE_VALUE )
		return true;
	::GetFileTime( h, NULL, NULL, &ft );
	::FileTimeToSystemTime( &ft, &StLocal );
	::CloseHandle( h );

	// Web̂̓̕t擾
	const char* p = dttm;
	SYSTEMTIME StWeb = StLocal;
	for( StWeb.wYear=0; *p && *p!='/'; ++p )
		StWeb.wYear = StWeb.wYear*10 + (*p-'0');
	if(*p)++p;
	for( StWeb.wMonth=0; *p && *p!='/'; ++p )
		StWeb.wMonth = StWeb.wMonth*10 + (*p-'0');
	if(*p)++p;
	for( StWeb.wDay=0; *p && *p!=' '; ++p )
		StWeb.wDay = StWeb.wDay*10 + (*p-'0');

	// Web̕PTԈȏV΍XVƂȊ

	if( (StLocal.wYear> StWeb.wYear)
	 || (StLocal.wYear==StWeb.wYear && StLocal.wMonth>StWeb.wMonth)
	 || (StLocal.wYear==StWeb.wYear && StLocal.wMonth==StWeb.wMonth && StLocal.wDay>=StWeb.wDay) )
		return false; // [J̕V̂ōXVȂ

	if( StLocal.wYear+2 < StWeb.wYear )
		return true; // mɂPNȏV̂ōXV
	if( StLocal.wYear+1 == StWeb.wYear )
		StWeb.wMonth += 12;

	// cfg->Expire ȏV΍XV
	StWeb.wDay += 30 * (StWeb.wMonth - StLocal.wMonth);
	return ( StLocal.wDay+cfg->Expire < StWeb.wDay );
}

bool DLLInfo::needToUpdate( kiPath& dlldir )
{
	// 擾łĂȂꍇ͍XVȂ
	if( vers.len() == 0 )
		return false;

	// ΏDLL̃tpX
	kiPath dllPath( dlldir );
	dllPath += name;

	// DLL݂Ȃꍇ͐VCXg[
	if( !kiSUtil::exist( dllPath ) )
	{
		stat.loadRsrc( IDS_NEWINST );
		return true;
	}

	// ݂ꍇAo[Wԍ擾Ă݂
	WORD ver=1, sub=0;
	if( name == "Zip32.dll" )
	{
		ver = Zip32DLLGetVersion( dllPath );
	}
	else if( name != "Sfx32gui.dat" )
	{
		kiArcDLLRaw dll( dllPath );
		ver = dll.getVer();
		sub = dll.getVerSub();
	}

	// ɕϊ
	char verstr[100];
	if( sub < 100 )
		::wsprintf( verstr, "%d.%02d", ver/100, ver%100 );
	else if( name=="7-zip32.dll" )
		::wsprintf( verstr, "%d.%02d.%02d.%02d", ver/100, ver%100, sub/100,sub%100 );
	else
		::wsprintf( verstr, "%d.%02d%c", ver/100, ver%100, sub/100+'a'-1 );

	// r
	bool updatable = false;
	if( CSTR_GREATER_THAN == ::CompareString(LOCALE_USER_DEFAULT,SORT_STRINGSORT,vers,-1,verstr,-1) )
	{
		// [JWEB̂̂̕VAƔ肳ƂɗB
		updatable = true;

		if( name=="Sfx32gui.dat" )
		{
			// Sfx32gui.dat̏ꍇ͓t`FbN
			updatable = CheckDateTime( dllPath );
		}
		else if( name=="Unrar32.dll" )
		{
			// Unrar32.dllŁAႢSubVersion̂Ƃ͓t`FbN
			::wsprintf( verstr, "%d.%02dz", ver/100, ver%100 );
			if( CSTR_GREATER_THAN == ::CompareString(LOCALE_USER_DEFAULT,SORT_STRINGSORT,verstr,-1,vers,-1) )
			{
				dllPath = dlldir;
				dllPath+= "Unrar.dll";
				updatable = CheckDateTime( dllPath );
			}
		}
	}

	// XV\
	if( updatable )
	{
		char str[100];
		::wsprintf( str, stat.loadRsrc( IDS_UPDINST ), (const char*)vers );
		stat = str;
	}
	return updatable;
}



//----------------------------------------------------------------------------
// startDlg : |JX^̑I
//----------------------------------------------------------------------------

class startDlg : public kiDialog
{
public:
	startDlg() : kiDialog( IDD_START ) {}

private:
	virtual BOOL onInit()
	{
		// dN֎~
		char cls[256], wnd[256];
		::GetClassName(  hwnd(), cls, sizeof(cls)-1 );
		::GetWindowText( hwnd(), wnd, sizeof(wnd)-1 );
		if( HWND h = ::FindWindow(cls,wnd) )
			if( h!=hwnd() || (h=::FindWindowEx(NULL,h,cls,wnd)) )
			{
				end( IDCANCEL );
				setFront( h );
				return FALSE;
			}

		app()->setMainWnd( this );
		UINT md = (cfg->AutoMode ? IDC_WORKTYPE1 : IDC_WORKTYPE2);
		sendMsgToItem( md, BM_SETCHECK, BST_CHECKED );
		return FALSE;
	}

	virtual bool onOK()
	{
		cfg->AutoMode =
			(BST_CHECKED == sendMsgToItem( IDC_WORKTYPE1, BM_GETCHECK ));
		return true;
	}
};



//----------------------------------------------------------------------------
// customDlg : ڑ/CXg[̑I vLV|ڍׂւ̕
//----------------------------------------------------------------------------

class customDlg : public kiDialog
{
public:
	customDlg() : kiDialog( IDD_CUSTOM1 ) {}

private:
	virtual BOOL onInit()
	{
		app()->setMainWnd( this );
		sendMsgToItem( IDC_DLLDIR, WM_SETTEXT, 0, (LPARAM)(const char*)(cfg->InstallTo) );
		sendMsgToItem( (cfg->CsdFirst ? IDC_CONNECTTO1 : IDC_CONNECTTO2), BM_SETCHECK, BST_CHECKED );
		return FALSE;
	}

	virtual BOOL CALLBACK proc( UINT msg, WPARAM wp, LPARAM lp )
	{
		if( msg==WM_COMMAND )
			if( LOWORD(wp)==IDC_REF )
			{
				kiSUtil::getFolderDlgOfEditBox( item(IDC_DLLDIR), hwnd(), NULL );
				return TRUE;
			}
			else if(  LOWORD(wp)==IDC_PROXY )
			{
				show( proxyDlg() );
				return TRUE;
			}
			else if(  LOWORD(wp)==IDC_DETAIL )
			{
				show( detailDlg() );
				return TRUE;
			}
		return FALSE;
	}

	virtual bool onOK()
	{
		char str[MAX_PATH];
		sendMsgToItem( IDC_DLLDIR, WM_GETTEXT, sizeof(str)-1, (LPARAM)str );
		cfg->InstallTo=str, cfg->InstallTo.beBackSlash( true );
		cfg->CsdFirst = (BST_CHECKED == sendMsgToItem( IDC_CONNECTTO1, BM_GETCHECK ));
		return true;
	}

	virtual bool onCancel()
	{
		return cancelShiteIidesuka();
	}

private:
	class detailDlg : public kiDialog
	{
	public:
		detailDlg() : kiDialog( IDD_DETAIL ) {}
	private:
		virtual BOOL onInit()
		{
			if( cfg->George )
				sendMsgToItem( IDC_CONNECT_ALWAYS, BM_SETCHECK, BST_CHECKED );
			if( cfg->ShowReadMe )
				sendMsgToItem( IDC_SHOW_README, BM_SETCHECK, BST_CHECKED );
			if( cfg->UseCustomDir )
				sendMsgToItem( IDC_SAVE_DESTDIR, BM_SETCHECK, BST_CHECKED );
			for( int i=0; i<DLLID_NUM; ++i )
				if( cfg->DoCheck[i] )
					sendMsgToItem( IDC_DLHA+i, BM_SETCHECK, BST_CHECKED );
			return FALSE;
		}

		virtual bool onOK()
		{
			cfg->George =
				(BST_CHECKED==sendMsgToItem( IDC_CONNECT_ALWAYS, BM_GETCHECK ));
			cfg->ShowReadMe =
				(BST_CHECKED==sendMsgToItem( IDC_SHOW_README, BM_GETCHECK ));
			cfg->UseCustomDir =
				(BST_CHECKED==sendMsgToItem( IDC_SAVE_DESTDIR, BM_GETCHECK ));
			for( int i=0; i<DLLID_NUM; ++i )
				cfg->DoCheck[i] =
					(BST_CHECKED==sendMsgToItem( IDC_DLHA+i, BM_GETCHECK ));
			return true;
		}
	};

	class proxyDlg : public kiDialog
	{
	public:
		proxyDlg() : kiDialog( IDD_PROXY ) {}
	private:
		virtual BOOL onInit()
		{
			if( cfg->ProxyPort>0 )
			{
				sendMsgToItem( IDC_USEPROXY, BM_SETCHECK, BST_CHECKED );
				::EnableWindow( item(IDC_HOST_N), TRUE );
				::EnableWindow( item(IDC_PORT_N), TRUE );
				::EnableWindow( item(IDC_HOST),   TRUE );
				::EnableWindow( item(IDC_PORT),   TRUE );
				::SetDlgItemInt( hwnd(), IDC_PORT, cfg->ProxyPort, FALSE );
			}
			else
				::SetDlgItemInt( hwnd(), IDC_PORT, -cfg->ProxyPort, FALSE );
			sendMsgToItem( IDC_HOST, WM_SETTEXT, 0, (LPARAM)(const char*)cfg->ProxyServer );
			return FALSE;
		}

		virtual BOOL CALLBACK proc( UINT msg, WPARAM wp, LPARAM lp )
		{
			if( msg==WM_COMMAND && LOWORD(wp)==IDC_USEPROXY )
			{
				BOOL x = ( BST_CHECKED==sendMsgToItem( IDC_USEPROXY, BM_GETCHECK ) );
				::EnableWindow( item(IDC_HOST_N), x );
				::EnableWindow( item(IDC_PORT_N), x );
				::EnableWindow( item(IDC_HOST),   x );
				::EnableWindow( item(IDC_PORT),   x );
				return TRUE;
			}
			return FALSE;
		}

		virtual bool onOK()
		{
			char str[500];
			sendMsgToItem( IDC_HOST, WM_GETTEXT, sizeof(str)-1, (LPARAM)str );
			cfg->ProxyServer = str;
			cfg->ProxyPort = ::GetDlgItemInt( hwnd(), IDC_PORT, NULL, FALSE );
			if( BST_CHECKED!=sendMsgToItem( IDC_USEPROXY, BM_GETCHECK ) )
				cfg->ProxyPort *= -1;
			return true;
		}
	};
};



//----------------------------------------------------------------------------
// verDlg : ڑĎۂ̃o[W`FbNs
//----------------------------------------------------------------------------

class verDlg : public kiDialog
{
public:
	verDlg( HINTERNET hi )
		: kiDialog( IDD_VERCHECK ), h(hi), ss(NULL), http(NULL) {}

	~verDlg()
	{
		if( ss )
			::InternetCloseHandle( ss );
		if( http )
			::InternetCloseHandle( http );
	}

private:

	HANDLE        hT;
	HINTERNET     h, http, ss;
	volatile bool m_endFlag;

	BOOL onInit()
	{
		app()->setMainWnd( this );
		sendMsgToItem( IDC_BAR, PBM_SETSTEP, 1 );
		sendMsgToItem( IDC_BAR, PBM_SETRANGE, 0, MAKELPARAM(0,cfg->List.len()*3) );

		m_endFlag = false;
		DWORD id;
		if( !(hT = ::CreateThread( NULL, 0, threadEntry, this, 0, &id )) )
			end( IDCANCEL );
		return FALSE;
	}

	bool onCancel()
	{
		m_endFlag = true;
		DWORD ex;
		while( ::GetExitCodeThread( hT, &ex ) && ex==STILL_ACTIVE )
			::Sleep(0);
		::CloseHandle( hT );
		return true;
	}

	static DWORD WINAPI threadEntry( void* prm )
	{
		((verDlg*)prm)->threadWorker();
		return 0;
	}

private:

	// Ɨp}N
	#define CHECK_CANCEL()      if(m_endFlag) break
	#define RETRY()             { ::InternetCloseHandle( http ); http=NULL; --Try; goto retry; }
	#define INET_CONNECT( __s ) ::InternetConnect( h, __s, INTERNET_DEFAULT_HTTP_PORT, NULL, NULL, INTERNET_SERVICE_HTTP, 0, 0 )
	#define HTTP_REQ( __n )     ::HttpOpenRequest( http, "GET", __n, "HTTP/1.0", NULL, NULL, 0, 0 )
	#define HTTP_SEND()         ::HttpSendRequest( ss, NULL, 0, NULL, 0 ), ::HttpQueryInfoA( ss, HTTP_QUERY_STATUS_CODE|HTTP_QUERY_FLAG_NUMBER,&status,&size,&dw),status;

	void threadWorker()
	{
		// ƕϐ
		const char* t;
		DWORD dw = 0, size = sizeof(DWORD), status;
		kiStr name;
		char buf[4000];

		// T[o萔ȂǂȂ
		const char* path[2]={ "/archiver/lib/", "/lib/" };
		const char* serv[2]={ "www.csdinc.co.jp", "archiver.wakusei.ne.jp" };
		if( cfg->CsdFirst ) t=path[0], path[0]=path[1], path[1]=t,
		                    t=serv[0], serv[0]=serv[1], serv[1]=t;

		// C[v
		int Try = 1;
		for( unsigned int i=0; i<cfg->List.len(); ++i )
		{
			// OtPXebvi߂
			CHECK_CANCEL();
			sendMsgToItem( IDC_BAR, PBM_STEPIT );

			// ڑȂAT[o֌qł݂
		retry:
			if( Try < 0 )
			{
				break;
			}
			else if( !http )
			{
				http = INET_CONNECT( serv[Try] );
				if( !http )
					RETRY();
			}

			// HTTPNGXg쐬
			name = path[Try];
			name+= cfg->List[i]->htmlName();
			ss   = HTTP_REQ( name );
			if( !ss )
				RETRY();
			CHECK_CANCEL();

			// HTTPNGXgM
			for( int j=0; j<3; ++j )
			{
				status = HTTP_SEND();

				if( status/100 == 2 )
				{
					// 200 Ȃ
					break;
				}
				else if( status != 407 )
				{
					// 404 Ȃ
					::InternetCloseHandle( ss );
					RETRY();
				}
				else
				{
					// 407 Proxy Authentication Required
					DWORD dwRet = ::InternetErrorDlg(
						hwnd(), ss, GetLastError(),
						FLAGS_ERROR_UI_FILTER_FOR_ERRORS |
						FLAGS_ERROR_UI_FLAGS_CHANGE_OPTIONS |
						FLAGS_ERROR_UI_FLAGS_GENERATE_DATA,
						NULL );

					if( dwRet != ERROR_INTERNET_FORCE_RETRY )
					{
						Try = -1;
						break;
					}
				}
			}

			// OtPXebvi߂
			CHECK_CANCEL();
			sendMsgToItem( IDC_BAR, PBM_STEPIT );

			// Ǎ
			DWORD read;
			::InternetReadFile( ss, buf, sizeof(buf)-1, &read );
			::InternetCloseHandle( ss );
			buf[ read ] = '\0';

			// OtPXebvi߂
			CHECK_CANCEL();
			sendMsgToItem( IDC_BAR, PBM_STEPIT );

			// 
			cfg->List[i]->ParseHTML( buf );
		}

		if( !m_endFlag )
			end( IDOK );
	}
};



//----------------------------------------------------------------------------
// dllDlg: _E[hDLL̑I
//----------------------------------------------------------------------------

class dllDlg : public kiDialog
{
public:
	dllDlg( kiArray<DLLInfo*>& upd ) : kiDialog( IDD_CUSTOM2 ), m_upd(upd) {}

private:
	kiArray<DLLInfo*>& m_upd;

	BOOL onInit()
	{
		app()->setMainWnd( this );

		SHFILEINFO fi;
		HIMAGELIST hI = (HIMAGELIST)::SHGetFileInfo(
			kiPath(kiPath::Sys)+="KERNEL32.DLL", 0, &fi, sizeof(fi),
			SHGFI_SYSICONINDEX | SHGFI_ICON | SHGFI_SMALLICON );
		int iDLL = fi.iIcon;
		int iEXE = kiSUtil::getSysIcon( "exe" );

		kiStr str;
		kiListView list( this, IDC_UPDATELIST );
		list.setImageList( NULL, hI );
		list.insertColumn( 0, str.loadRsrc( IDS_LV_DLLNAME ), 120 );
		list.insertColumn( 1, str.loadRsrc( IDS_LV_STATE ), 110 );
		for( unsigned int i=0; i<m_upd.len(); i++ )
		{
			list.insertItem( i, m_upd[i]->getName(), 0, strcmpi( "dll", kiPath::ext(m_upd[i]->getName()) ) ? iEXE : iDLL );
			list.setSubItem( i, 1, m_upd[i]->getState() );
		}
		sendMsgToItem( IDC_UPDATELIST,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_CHECKBOXES,LVS_EX_CHECKBOXES );
		for( i=0; i!=m_upd.len(); i++ )
			ListView_SetCheckState( item(IDC_UPDATELIST), i, TRUE );
		for( int j=0; j!=3; j++ )
			sendMsgToItem( IDC_INSTMODE1+j,BM_SETCHECK,j==cfg->InstMode ? BST_CHECKED : BST_UNCHECKED );
		return FALSE;
	}
	bool onCancel()
	{
		if( !cancelShiteIidesuka() )
			return false;
		kiListView( this, IDC_UPDATELIST ).setImageList( NULL, NULL );
		return true;
	}
	bool onOK()
	{
		for( unsigned int i=0; i!=3; i++ )
			if( BST_CHECKED == sendMsgToItem( IDC_INSTMODE1+i, BM_GETCHECK ) )
			{
				cfg->InstMode = i;
				break;
			}

		kiArray<DLLInfo*> res;
		res = m_upd, m_upd.empty();
		for( i=0; i<res.len(); i++ )
			if( ListView_GetCheckState( item(IDC_UPDATELIST), i ) )
				m_upd.add( res[i] );

		kiListView( this, IDC_UPDATELIST ).setImageList( NULL, NULL );
		return true;
	}
};



//----------------------------------------------------------------------------
// downloadDlg : _E[h
//----------------------------------------------------------------------------

class downloadDlg : public kiDialog, IBindStatusCallback
{
public:
	downloadDlg( const kiArray<DLLInfo*>& lst, const kiPath& pth )
		: kiDialog( IDD_VERCHECK ), m_lst( lst ), m_pth( pth ), m_cRef( 1 ){}

private:
	const kiArray<DLLInfo*>& m_lst;
	const kiPath& m_pth;
	unsigned long m_cRef;
	unsigned long m_total;
	unsigned long m_step;
	unsigned long m_startTime, m_lastTime;
	bool m_stateCancel;

	BOOL onInit()
	{
		app()->setMainWnd( this );

		// _E[h萔ȂǂȂ
		int Try = 1;
		const char* dlfrom[2] =
			{ "http://www.csdinc.co.jp/archiver/lib/"
			, "http://archiver.wakusei.ne.jp/lib/" };
		if( cfg->CsdFirst )
			{ const char* t=dlfrom[0]; dlfrom[0]=dlfrom[1]; dlfrom[1]=t; }

		m_startTime = m_lastTime = ::GetTickCount();
		m_stateCancel = false;
		m_step = m_total = 0;
		for( unsigned int i=0; i<m_lst.len(); i++ )
			m_total += m_lst[i]->getSize();
		sendMsgToItem( IDC_BAR, PBM_SETRANGE,0, MAKELPARAM(0,32768) );
		setTimeInfo( 0 );
		::ShowWindow( hwnd(), SW_SHOW );
		::UpdateWindow( hwnd() );

		kiPath url, fil;
		char msg[300];
		for( i=0; i<m_lst.len(); i++ )
		{
			::wsprintf( msg, kiStr().loadRsrc(IDS_DOWNLOADING), (const char*)m_lst[i]->getName() );
			sendMsgToItem( IDC_MSG, WM_SETTEXT, 0, (LPARAM)msg );
			::EnableWindow( item(IDC_MSG), FALSE );
			::EnableWindow( item(IDC_MSG), TRUE );

		retry:
			url = dlfrom[Try], url += m_lst[i]->getArchiveName();
			fil = m_pth,       fil += m_lst[i]->getArchiveName();
			if( S_OK != ::URLDownloadToFile( NULL, url, fil, 0, this ) )
			{
				if( 0>--Try )
				{
					app()->msgBox( kiStr(1000).loadRsrc( IDS_DLERROR ), "caldix", MB_ICONINFORMATION|MB_SYSTEMMODAL );
					break;
				}
				goto retry;
			}
			m_step += m_lst[i]->getSize();
		}
		if( i==m_lst.len() )
			end( IDOK );
		else
			end( IDCANCEL );

		return FALSE;
	}
	bool onCancel()
	{
		if( cancelShiteIidesuka() )
			m_stateCancel = true;
		return false;
	}

public:
	void setTimeInfo( unsigned long bytesread )
	{
		int sec = (bytesread==0 || m_lastTime==m_startTime)
		  ? (int)((double)(m_total) / 7000)
		  : (int)((double)((m_total-bytesread)) * (m_lastTime - m_startTime) / 1000 / bytesread);

		static char str[300];
		::wsprintf( str, (const char*)(kiStr().loadRsrc(IDS_REST)),
			(m_total-bytesread)/1000, sec/60, sec%60 );

		sendMsgToItem( IDC_RESTTIME, WM_SETTEXT, 0, (LPARAM)str );
	}

	STDMETHODIMP_(ULONG) AddRef()	{ return (++m_cRef); }
	STDMETHODIMP_(ULONG) Release()	{ return (m_cRef ? --m_cRef : 0L); }
	STDMETHODIMP GetBindInfo( DWORD*, BINDINFO* ) { return E_NOTIMPL; }
	STDMETHODIMP GetPriority( LONG* ) { return E_NOTIMPL; }
	STDMETHODIMP OnLowResource( DWORD ) { return E_NOTIMPL; }
	STDMETHODIMP OnDataAvailable( DWORD, DWORD, FORMATETC*, STGMEDIUM* ) { return E_NOTIMPL; }
	STDMETHODIMP OnObjectAvailable( REFIID, IUnknown* ) { return E_NOTIMPL; }
	STDMETHODIMP OnStartBinding( DWORD, IBinding* ) { return E_NOTIMPL; }
	STDMETHODIMP OnStopBinding( HRESULT, LPCWSTR ) { return E_NOTIMPL; }
	STDMETHODIMP QueryInterface( REFIID riid, void** ppv )
	{
		*ppv = NULL;
		AddRef();
		if( IsEqualIID( riid, IID_IUnknown ) || IsEqualIID( riid, IID_IBindStatusCallback ) )
			*ppv = (IBindStatusCallback*)this;
		else
		{
			Release();
			return E_NOINTERFACE;
		}
		return NOERROR;
	}
	STDMETHODIMP OnProgress( ULONG cur, ULONG max, ULONG status, LPCWSTR txt )
	{
		msgLoop( PEEK );

		if( m_stateCancel )
		{
			end( IDCANCEL );
			return E_ABORT;
		}

		DWORD time = ::GetTickCount();
		if( time-m_lastTime >= 5000 )
		{
			m_lastTime = time;
			setTimeInfo( m_step+cur );
		}

		sendMsgToItem( IDC_BAR, PBM_SETPOS, (int)(((double)(m_step+cur))/m_total*32768) );
		return S_OK;
	}
};



//----------------------------------------------------------------------------
// instDlg : systemփCXg[
//----------------------------------------------------------------------------

class instDlg : public kiDialog
{
public:
	instDlg( kiArray<DLLInfo*>& upd, const kiPath& arcdir, const kiPath& work, const kiPath& to )
		: kiDialog( IDD_INSTALL ), m_upd( upd ), m_arcdir( arcdir ), m_workdir( work ), m_dlldir( to ) {}

private:
	kiArray<DLLInfo*>& m_upd;
	const kiPath& m_arcdir;
	const kiPath& m_workdir;
	const kiPath& m_dlldir;
	bool onCancel()	{ return false; }
	bool onOK()		{ return false; }

	BOOL onInit()
	{
		bool needreboot=false;
		app()->setMainWnd( this );
		::ShowWindow( hwnd(), SW_SHOW );
		::UpdateWindow( hwnd() );
		//-- 𓀁CXg[Jn` ---------------

		char tmp[MAX_PATH];
		kiPath arc, dll, path;
		for( unsigned int i=0; i<m_upd.len(); i++ )
		{
			// ɖ:tpX
			arc = m_arcdir, arc += m_upd[i]->getArchiveName();
			// hLgۑ:tpX
			dll = m_workdir, ::lstrcpyn(tmp,m_upd[i]->getName(),m_upd[i]->getName().len()-3), dll += tmp, dll.remove();
			dll += "\\", dll.mkdir(), ::SetCurrentDirectory( dll );
			// 𓀁i path=ɓDLL̑΃pX j
			melt_it( arc, m_upd[i]->getName(), path );
			// CXg[
			if( !install_it( dll, path ) )
			{
				needreboot = true;
			}
			if( path.isSame( "aish32.dll" ) )
			{
				if( !install_it( dll, "Aishmv32.dll" ) )
					needreboot = true;
			}
			else if( path.isSame( "unrar32.dll" ) )
			{
				if( !install_it( dll, "unrar.dll" ) )
					needreboot = true;
			}
			else if( path.isSame( "yz1.dll" ) )
			{
				if( !install_it( dll, "yzdec.exe" ) )
					needreboot = true;
				kiPath uyz( m_dlldir );
				if( !kiSUtil::exist( uyz+="UnYz1.dll" ) )
					if( !install_it( dll, "UnYz1.dll" ) )
						needreboot = true;
			}
			// bZ[W
			msg();
		}

		//-- 𓀁CXg[I` ---------------
		end( needreboot ? IDCANCEL : IDOK );
		return FALSE;
	}

private:
	bool install_it( const char* position, const char* relpath )
	{
		kiPath from( position ); from += relpath;
		if( ::GetFileAttributes(from) != 0xffffffff )
		{
			kiPath to( m_dlldir ); to += kiPath::name(relpath);
			if( ::CopyFile( from, to, FALSE ) )
				::DeleteFile( from );
			else
			{
				// ċNRs[
				move_later( from, to );
				return false;
			}
		}
		return true;
	}
};



//----------------------------------------------------------------------------
// caldix : C[`
//----------------------------------------------------------------------------

#include <ras.h>
#include <raserror.h>

class caldix : public kiApp
{
	caldix()
	{
		shellInit();
		kiutil::pathInit();

		cfg = new CldxConfig;
	}

	void run( kiCmdParser& cmd )
	{
		// _CAO [S/JX^]
		if( !cfg->SuperAutoMode && !show( startDlg() ) )
			return;

		if( cfg->AutoMode )
		{
			// SȂACXg[VXeɂ邩Ȃ
			if( !cfg->UseCustomDir )
				cfg->InstallTo.beSpecialPath( kiPath::Sys );
		}
		else
		{
			// _CAO [CXg[Ƃ]
			if( !show( customDlg() ) )
				return;
		}

		// ݒ̒
		cfg->InstallTo.beBackSlash( true );
		cfg->GenerateDLLList();

		// 펞ڑ[hłȂꍇAڑm
		if( !cfg->George )
			if( ERROR_SUCCESS != ::InternetAttemptConnect(0) )
			{
				msgBox( kiStr().loadRsrc( IDS_NOINTERNET ) );
				return;
			}

		// WinInetJnc
		HINTERNET h = ::InternetOpen( cfg->UA, INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0 );
		if( !h )
		{
			msgBox( kiStr().loadRsrc( IDS_NOINTERNET ) );
			return;
		}

		// vNV̐ݒ
		if( cfg->ProxyServer.len() && cfg->ProxyPort>0 )
		{
			kiStr pr( "http=http://" );
			pr += cfg->ProxyServer;
			pr += ':';
			pr += kiStr().setInt(cfg->ProxyPort);
			INTERNET_PROXY_INFO pi = {INTERNET_OPEN_TYPE_PROXY,(const char*)pr,"<local>"};
			::InternetSetOption(  h, INTERNET_OPTION_PROXY, (void*)&pi, sizeof(pi) );
			::UrlMkSetSessionOption( INTERNET_OPTION_PROXY, (void*)&pi, sizeof(pi), 0 );
		}

		// ^CAEg7b
		DWORD TimeOut = 7*1000;
		::InternetSetOption( h, INTERNET_OPTION_RECEIVE_TIMEOUT, &TimeOut, sizeof(TimeOut) );

		// _CAO [WWWC META CHECK]
		if( !show( verDlg(h) ) )
		{
			::InternetCloseHandle( h );
			askRasHangUp();
			return;
		}

		// o[Wr
		kiStr tmp;
		kiArray<DLLInfo*> upd;
		for( unsigned int i=0; i<cfg->List.len(); ++i )
			if( cfg->List[i]->needToUpdate( cfg->InstallTo ) )
				upd.add( cfg->List[i] );

		if( upd.len()==0 )
		{
			::InternetCloseHandle( h );
			msgBox( kiStr().loadRsrc( IDS_NONEED ), "caldix", MB_ICONINFORMATION );
			askRasHangUp();
			return;
		}

		if( ! cfg->AutoMode )
		{
			// _CAO [CXg[DLLƂ]
			if( !show(dllDlg(upd)) || upd.len()==0 )
			{
				::InternetCloseHandle( h );
				askRasHangUp();
				return;
			}
		}

		// _E[h
		char buf[MAX_PATH];
		::GetTempFileName( kiPath( kiPath::Tmp ), "cld", 0, buf );
		::DeleteFile( buf );
		kiPath dlto( buf );
		dlto.beBackSlash( true );
		dlto.mkdir();

		if( !show( downloadDlg(upd, dlto) ) )
		{
			dlto.remove();
			::InternetCloseHandle( h );
			askRasHangUp();
			return;
		}

		// CXg[
		bool needreboot = false;
		cfg->InstallTo.mkdir();
		kiPath workDir( kiPath::Exe ); workDir.lower();
		UINT drv = workDir.getDriveType();
		if( strstr(workDir,"temporary internet files")!=NULL
		 || (drv!=DRIVE_FIXED && drv!=DRIVE_REMOTE && drv!=DRIVE_UNKNOWN) )
			workDir.beSpecialPath( kiPath::Dsk ), workDir.beBackSlash( true );
		workDir += "cldx\\";
		workDir.mkdir();

		if( cfg->InstMode != 1 )
		{
			// ɃRs[
			kiPath from, to;
			for( unsigned int i=0; i<upd.len(); i++ )
			{
				from = dlto, from += upd[i]->getArchiveName();
				to = workDir,  to += upd[i]->getArchiveName();
				::CopyFile( from, to, FALSE );
			}
		}
		if( cfg->InstMode != 0 )
		{
			// CXg[
			if( !show( instDlg( upd, dlto, workDir, cfg->InstallTo ) ) )
				needreboot = true;
		}

		// 
		dlto.remove();
		::InternetCloseHandle( h );

		if( !needreboot )
		{
			if( ! cfg->SuperAutoMode )
				msgBox( kiStr(500).loadRsrc( IDS_FINISHED ), "caldix", MB_ICONINFORMATION|MB_SYSTEMMODAL );
			askRasHangUp();
		}
		else
			if( IDYES!=msgBox( kiStr(1000).loadRsrc( IDS_REBOOT ), "caldix", MB_ICONINFORMATION|MB_YESNO|MB_SYSTEMMODAL ) )
				needreboot = false;

		// ȈՐo
		if( ::GetACP() == 932 )
		{
			kiFile fp;
			if( fp.open( kiPath(workDir)+="ǂł.txt", false ) )
			{
				static const char * text =
"̃tH_ɂ́AcaldixŃ_E[hꂽ\r\n"
"DLL̐i[Ă܂B悭ǂ݉B\r\n"
"\r\n"
" UNZIP32.DLL Ɠŗpꍇɂ́AK\r\n"
" CZX_񂪕KvłBڍׂ͉Ly[WɂāB\r\n"
" http://www.csdinc.co.jp/archiver/lib/unzip32.html\r\n"
"\r\n"
"ꂼDLL̍җl̃TCǵA\r\n"
" wA[JCovWFNgx\r\n"
" @@http://www.csdinc.co.jp/archiver/ \r\n"
"烊NǂĖK邱Ƃo܂B\r\n"
"x͍sĂ݂邱Ƃ߂܂B\r\n"
"\r\n"
"DLL̃ACXg[ uncaldix ֗B\r\n"
"     http://www6.plala.or.jp/amasoft/soft/uncaldix.html\r\n"
"\r\n"
"caldixɊւ邲ⓙ( http://kinaba.cjb.net/ )\r\n"
				; fp.write( text, ki_strlen(text) );
			}
		}

		// o͐J
		if( cfg->ShowReadMe )
		{
			char cmdline[1000];
			::wsprintf( cmdline, "explorer \"%s\"", (const char*)workDir );
			::WinExec( cmdline, SW_SHOWDEFAULT );
		}

		if( needreboot )
			rebootWindows(); // ċNŁ[
	}

	void askRasHangUp()
	{
		// uȂ[h
		if( cfg->George )
			return;

		// DLL,yѕKvȊ֐[h
		HINSTANCE rasdll = ::LoadLibrary( "RASAPI32.DLL" );
		if( rasdll == NULL )
			return;
		typedef DWORD (WINAPI * rE)( LPRASCONN,LPDWORD,LPDWORD );
		typedef DWORD (WINAPI * rH)( HRASCONN );
		typedef BOOL  (WINAPI * rS)( HRASCONN,LPRASCONNSTATUS );
		rE RasEnumConnections = (rE)::GetProcAddress( rasdll, "RasEnumConnectionsA" );
		rH RasHangUp          = (rH)::GetProcAddress( rasdll, "RasHangUpA" );
		rS RasGetConnectStatus= (rS)::GetProcAddress( rasdll, "RasGetConnectStatusA" );
		if( RasEnumConnections!=NULL && RasHangUp!=NULL && RasGetConnectStatus!=NULL )
		{
			RASCONN* RasConn = new RASCONN[1];
			DWORD Num, Size = sizeof(RASCONN);
			RasConn->dwSize = sizeof(RASCONN);
			int Sts = RasEnumConnections( RasConn, &Size, &Num );
			if( (Sts==ERROR_BUFFER_TOO_SMALL) || (Sts==ERROR_NOT_ENOUGH_MEMORY) )
			{
				delete [] RasConn;
				RasConn = new RASCONN[Size/sizeof(RASCONN)];
				Sts = RasEnumConnections( RasConn, &Size, &Num );
			}
			if( Sts==0 && Num>=1 )
			{
				// uB
				if( IDYES==msgBox( kiStr(1000).loadRsrc( IDS_RASHANGUP ), "caldix", MB_ICONINFORMATION|MB_YESNO|MB_SYSTEMMODAL ) )
				{
					// ؂
					RASCONNSTATUS RasSts;
					RasSts.dwSize = sizeof(RASCONNSTATUS);
					for( DWORD i=0; i<Num; i++ )
					{
						RasHangUp( RasConn->hrasconn );
						while( RasGetConnectStatus( RasConn->hrasconn, &RasSts ) != ERROR_INVALID_HANDLE )
							::Sleep( 10 );
					}
				}
			}
			delete [] RasConn;
		}
		::FreeLibrary( rasdll );
	}

	~caldix()
	{
		delete cfg;
	}

	friend void kilib_create_new_app();
};

void kilib_create_new_app()
{
	new caldix;
}
